﻿//パッケージマネージャーコンソールに
//dotnet add package Azure.AI.OpenAI --prerelease
//dotnet add package OpenAI
//の入力が必要です

//以下、お使いになるプログラムの行頭コメント（//）を削除して使ってください。

//コメントの削除は［Ctrl(command)］＋［K］→［Ctrl(command)］＋［U］キー
//コメントをつけるには［Ctrl(command)］＋［K］→［Ctrl(command)］＋［C］キー

//リスト5-2-1
using Azure.AI.OpenAI;
using System.Text.Json;

const string API_KEY = "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"; // ☆
const string MODEL_NAME = "text-embedding-ada-002";

var client = new OpenAIClient(API_KEY);

Console.Write("prompt: ");
var prompt = Console.ReadLine() ?? "Hello.";

var options = new EmbeddingsOptions(prompt);
var response = client.GetEmbeddings(MODEL_NAME, options);

var values = response.Value;
foreach (var item in values.Data)
{
    Console.WriteLine(JsonSerializer.Serialize(item.Embedding));
}


//リスト5-4-1
//using Azure.AI.OpenAI;
//using System.Text.Json;
//using System.Text;

//const string API_KEY = "《APIキー》"; // ☆
//const string MODEL_NAME = "text-embedding-ada-002";

//var client = new OpenAIClient(API_KEY);

//Console.Write("title: ");
//var title = Console.ReadLine() ?? "Hello.";
//Console.Write("description: ");
//var description = Console.ReadLine() ?? "Hello.";

//var options = new EmbeddingsOptions(description);
//var response = client.GetEmbeddings(MODEL_NAME, options);

//var values = response.Value;
//var embed = JsonSerializer.Serialize(values.Data[0].Embedding);
//Console.WriteLine(embed);

//string desktop = Environment.GetFolderPath(Environment.SpecialFolder.DesktopDirectory);
//string fpath = desktop + "/output.csv";

//try
//{
//using (StreamWriter writer = new StreamWriter(fpath, true, Encoding.UTF8, 20000))
//    {
//        var data = $"\"{title}\",\"{description}\",\"{embed}\"";
//        writer.Write(data);
//        writer.WriteLine();
//        writer.Flush();
//        writer.Close();
//    };
//}
//catch (IOException ex)
//{
//    Console.WriteLine("CSVファイルの読み込みエラー：" + ex.Message);
//}


//リスト5-5-1 ※このままでは実行できません
//double GetCosineSimilarity(float[]? vector1, float[]? vector2)
//{
//    if (vector1 == null || vector2 == null)
//    {
//        return 0;
//    }
//    int count = vector1.Count() < vector2.Count() ? vector1.Count() : vector2.Count(); 
//    double dot = 0.0d;
//    double mag1 = 0.0d; 
//    double mag2 = 0.0d;
//    for (int n = 0; n < count; n++)
//    {
//        dot += vector1[n] * vector2[n];
//        mag1 += Math.Pow(vector1[n], 2);
//        mag2 += Math.Pow(vector2[n], 2);
//    }
//    return dot / (Math.Sqrt(mag1) * Math.Sqrt(mag2)); 
//}


//リスト5-5-2
//using Azure.AI.OpenAI;
//using System.Text;
//using Newtonsoft.Json;
//using System.Reflection.PortableExecutable;
//// コサイン類似度の計算関数
//double GetCosineSimilarity(float[]? vector1, float[]? vector2)
//{
//    if (vector1 == null || vector2 == null)
//    {
//        return 0;
//    }
//    int count = vector1.Count() < vector2.Count() ? vector1.Count() : vector2.Count(); 
//    double dot = 0.0d;
//    double mag1 = 0.0d; 
//    double mag2 = 0.0d;
//    for (int n = 0; n < count; n++)
//    {
//        dot += vector1[n] * vector2[n];
//        mag1 += Math.Pow(vector1[n], 2);
//        mag2 += Math.Pow(vector2[n], 2);
//    }
//    return dot / (Math.Sqrt(mag1) * Math.Sqrt(mag2)); 
//}

//const string API_KEY = "《APIキー》"; // ☆
//const string MODEL_NAME = "text-embedding-ada-002";
//var client = new OpenAIClient(API_KEY);

//// プロンプトの入力
//Console.Write("prompt: ");
//var prompt = Console.ReadLine() ?? "Hello.";
//// Embeddingしたデータを取得
//var options = new EmbeddingsOptions(prompt);
//var response = client.GetEmbeddings(MODEL_NAME, options);
//// データからベクトルデータを変数に取得
//var values = response.Value;
//float[]? embedded_data = values.Data[0].Embedding.ToArray();

//// CSVファイルのロード
//string desktop = Environment.GetFolderPath(Environment.SpecialFolder.DesktopDirectory); 
//string fpath = desktop + "/output.csv";

//// データ保管用のリストの用意
//List<EmbeddingData> embedding_data = new List<EmbeddingData>();
//// CSVデータからJSONフォーマットを作成
//try
//{
//    using (StreamReader reader = new StreamReader(fpath, Encoding.UTF8))
//    {
//        string? line;
//        _ = reader.ReadLine();
//        while ((line = reader.ReadLine()) != null) 
//    {
//            // 行データをカンマで分割しJSONフォーマットにする
//            var arr = line.Split(",");
//            var json_str = $"{{title:\"{arr[0]}\",description:\"{arr[1]}\"," + $"embedding: { String.Join(",", arr.Skip(2))}}}";
//　　　　　　　// JSONデータからEmbeddingDataを生成
//　　　　　　　　　　　EmbeddingData? data = JsonConvert.DeserializeObject<EmbeddingData>(json_str);
//    　　　　　　　　if (data != null) // オブジェクトが生成できていたらリストに追加
//   　　　　 　　　　{
//   　　　　 　　　　　　　　embedding_data.Add(data);
//   　　　　　　　　 }
//　　　　　　　　}
//　　　　reader.Close();
//　　　　};
//}
//catch (IOException ex) //例外処理
//{
//    Console.WriteLine("CSVファイルの読み込みエラー：" + ex.Message);
//}

//// もっとも値の高いデータを保管しておく変数
//EmbeddingData? select = null;
//double last_CS = 0;

//// コサイン類似度を計算する
//foreach (EmbeddingData embeded_item in embedding_data) 
//{
//    　double CS = GetCosineSimilarity(embedded_data, embeded_item.embedding); 
//　　　if (CS > last_CS) // 類似度がlast_CSを上回ったら変数を更新
//    　{
//        　　last_CS = CS; 
//　　　　　　　select = embeded_item;
//　    }
//}
//// 結果を表示
//Console.Write("Result: ");
//if (select != null)
//{
//    Console.WriteLine(select.title);
//}
//else
//{
//    Console.WriteLine("見つかりませんでした。");
//}

//// CSVデータの定義用クラス
//class EmbeddingData
//{
//    public string? title;
//    public string? description;
//    public float[]? embedding;
//}

//リスト5-6-1　※このままでは実行できません
//{ "prompt":"今日もいい天気で朝から気分がいいな！","completion":"ポジティブ\n"}
//{ "prompt":"新作ゲームをゲットしたぜ！帰ったら徹夜でやるぞ。","completion":"ポジティブ\n"}
//{ "prompt":"取引先との打ち合わせもうまくいって、上司に褒められたよ。","completion":"ポジティブ\n"}
//{ "prompt":"また今日も雨か。毎日ジメジメとして、梅雨はキライだ。","completion":"ネガティブ\n"}
//{ "prompt":"なんで使えない部下の責任をオレが取らないといけないんだよ。","completion":" ネガティブ\n"}
//{ "prompt":"忙しいのはわかるけど、ドタキャンするなよ。前もって連絡できただろ？","completion":" ネガティブ\n"}

//リスト5-6-2　※このままでは実行できません
//{ "prompt":"今日は久しぶりに彼女とデートだ。高級レストラン予約したぞ！","completion":"ポジティブ\n"}
//{ "prompt":"お友達でいましょうって、要はオレとは付き合えないってことだよな。","completion":" ネガティブ\n"}


//リスト5-10-3
//using Azure;
//using Azure.AI.OpenAI;
//using System.Text.Json;
//const string END_POINT = "《エンドポイント》"; // ☆
//const string API_KEY = "《APIキー》"; // ☆
//const string MODEL_NAME = "《モデル名》"; // ☆

//var client = new OpenAIClient(
//    new Uri(END_POINT),
//    new AzureKeyCredential(API_KEY));

//// プロンプトの入力
//Console.Write("prompt: ");
//var prompt = Console.ReadLine() ?? "Hello.";

//var options = new CompletionsOptions()
//{
//    Prompts = { prompt },
//    MaxTokens = 10,
//};
//options.StopSequences.Add("\n");

//var response = client.GetCompletions(
//    MODEL_NAME,
//    options);
//var completion = response.Value;
//Console.WriteLine(completion.Choices[0].Text);

