﻿//パッケージマネージャーコンソールに
//dotnet add package Azure.AI.OpenAI --prerelease
//dotnet add package OpenAI
//dotnet add package Microsoft.CognitiveServices.Speech
//dotnet add package Azure.AI.Vision.ImageAnalysis --prerelease
//dotnet add package Azure.AI.ContentSafety --prerelease
//の入力が必要です

//以下、お使いになるプログラムの行頭コメント（//）を削除して使ってください。

//コメントの削除は［Ctrl(command)］＋［K］→［Ctrl(command)］＋［U］キー
//コメントをつけるには［Ctrl(command)］＋［K］→［Ctrl(command)］＋［C］キー

//リスト7-4-1
//using Microsoft.CognitiveServices.Speech;
//using Microsoft.CognitiveServices.Speech.Audio;
//const string SPEECH_KEY = "《リソースキー》"; //☆
//const string REGION = "《リージョン》"; //☆

//// SpeechConfigの用意
//var speechConfig = SpeechConfig.FromSubscription(SPEECH_KEY, REGION);
//speechConfig.SpeechRecognitionLanguage = "ja-JP";
//// AudioConfigの用意
//using var audioConfig = AudioConfig.FromDefaultMicrophoneInput();

//// SpeechRecognizerの作成
//using var recognizer = new SpeechRecognizer(speechConfig, audioConfig); 
//Console.WriteLine("※マイクに話しかけてください。");
//// 音声認識の実行
//var recognition = await recognizer.RecognizeOnceAsync(); 

//// 認識結果の処理
//switch (recognition.Reason)
//{
//    case ResultReason.RecognizedSpeech: //認識
//        Console.WriteLine("音声認識しました：Text=" + recognition.Text); 
//        break;
//    case ResultReason.NoMatch: //失敗
//        Console.WriteLine("音声が認識されません。");
//        break;
//    case ResultReason.Canceled: //キャンセル
//        var cancellation = CancellationDetails.FromResult(recognition);
//        Console.WriteLine("キャンセルされました。（" + cancellation.Reason + "）");
//        break;
//}


//リスト7-6-1
//using Microsoft.CognitiveServices.Speech;

//const string SPEECH_KEY = "《リソースキー》"; //☆
//const string REGION = "《リージョン》"; //☆

//// SpeechConfigの用意
//var speechConfig = SpeechConfig.FromSubscription(SPEECH_KEY, REGION);
//speechConfig.SpeechRecognitionLanguage = "ja-JP";

//speechConfig.SpeechSynthesisVoiceName = "ja-JP-NanamiNeural"; 

//using var speechSynthesizer = new SpeechSynthesizer(speechConfig);

//// テキストを入力する
//Console.Write("テキストを入力：");
//string? prompt = Console.ReadLine();

//var synthesis_result = await speechSynthesizer.SpeakTextAsync(prompt);

//// 認識結果の処理
//switch (synthesis_result.Reason)
//{
//    case ResultReason.SynthesizingAudioCompleted:
//        Console.WriteLine($"再生するテキスト [{prompt}]");
//        break;
//    case ResultReason.Canceled:
//        var cancellation = SpeechSynthesisCancellationDetails.
//        FromResult(synthesis_result);
//        Console.WriteLine($"キャンセルされました。: {cancellation.Reason}");
//        break;
//}


////リスト7-9-1
//using Azure;
//using Azure.AI.Vision.Common;
//using Azure.AI.Vision.ImageAnalysis;

//const string END_POINT = "《エンドポイント》"; //☆
//const string VISION_KEY = "《リソースキー》"; //☆

////const string SOURCE_PATH = "https://learn.microsoft.com/azure/cognitive-" + "services/computer-vision/media/quickstarts/presentation.png";

//// VisionServiceOptionsの作成
//var service_options = new VisionServiceOptions(
//    new Uri(END_POINT),
//    new AzureKeyCredential(VISION_KEY));

//// VisionSourceの作成
//using var image_source = VisionSource.FromUrl(SOURCE_PATH);

//// ImageAnalysisOptionsの作成
//var analysis_options = new ImageAnalysisOptions();

//// ImageAnalysisOptionsの設定
//analysis_options.Features = ImageAnalysisFeature.Text;
//analysis_options.Language = "en";
//analysis_options.GenderNeutralCaption = true;

//// ImageAnalyzerの作成
//using var analyzer = new ImageAnalyzer(service_options, image_source,analysis_options);

//// 分析の実行
//var result = analyzer.Analyze();

//// 正常に分析できたかチェック
//if (result.Reason == ImageAnalysisResultReason.Analyzed)
//{
//    if (result.Text != null) // テキストが取得できたか？
//    {
//        Console.WriteLine("Text:");
//        foreach (var line in result.Text.Lines)
//        {
//            Console.Write(" Line:" + line.Content);
//            foreach (var word in line.Words)
//            {
//            Console.Write(" " + word.Content); 
//            }
//            Console.WriteLine();
//        }
//        Console.WriteLine();
//    }
//}


////リスト7-9-2
//using Azure;
//using Azure.AI.Vision.Common;
//using Azure.AI.Vision.ImageAnalysis;

//const string END_POINT = "《エンドポイント》"; //☆
//const string VISION_KEY = "《リソースキー》"; //☆

//// VisionServiceOptionsの作成
//var service_options = new VisionServiceOptions(
//    new Uri(END_POINT),
//    new AzureKeyCredential(VISION_KEY));

//// VisionSourceの作成
//var desktop = Environment.GetFolderPath(Environment.SpecialFolder.DesktopDirectory);
//var SOURCE_PATH = desktop + "/〇〇.jpg";　//ファイル名を指定してください
//using var image_source = VisionSource.FromFile(SOURCE_PATH);


//// ImageAnalysisOptionsの作成
//var analysis_options = new ImageAnalysisOptions();

//// ImageAnalysisOptionsの設定
//analysis_options.Features = ImageAnalysisFeature.Text;
//analysis_options.Language = "en";
//analysis_options.GenderNeutralCaption = true;

//// ImageAnalyzerの作成
//using var analyzer = new ImageAnalyzer(service_options, image_source,analysis_options);

//// 分析の実行
//var result = analyzer.Analyze();

//// 正常に分析できたかチェック
//if (result.Reason == ImageAnalysisResultReason.Analyzed)
//{
//    if (result.Text != null) // テキストが取得できたか？
//    {
//        Console.WriteLine("Text:");
//        foreach (var line in result.Text.Lines)
//        {
//            Console.Write(" Line:" + line.Content);
//            foreach (var word in line.Words)
//            {
//            Console.Write(" " + word.Content); 
//            }
//            Console.WriteLine();
//        }
//        Console.WriteLine();
//    }
//}

//リスト7-9-3,7-9-4
//using Azure;
//using Azure.AI.Vision.Common;
//using Azure.AI.Vision.ImageAnalysis;
//const string END_POINT = "《エンドポイント》"; //☆
//const string VISION_KEY = "《リソースキー》"; //☆
//const string SOURCE_PATH = "https://learn.microsoft.com/azure/cognitive-" + "services/computer-vision/media/quickstarts/presentation.png";

//// VisionServiceOptionsの作成
//var service_options = new VisionServiceOptions(
//new Uri(END_POINT),
//new AzureKeyCredential(VISION_KEY));
//// VisionSourceの作成
//using var image_source = VisionSource.FromUrl(SOURCE_PATH);



//// ImageAnalysisOptionsの作成
//var analysis_options = new ImageAnalysisOptions();


//// ImageAnalysisOptionsの設定
//analysis_options.Features = ImageAnalysisFeature.Objects; //変更
//analysis_options.Language = "en";
//analysis_options.GenderNeutralCaption = true;
//// ImageAnalyzerの作成
//using var analyzer = new ImageAnalyzer(service_options, image_source, analysis_options);

//// 分析の実行
//var result = analyzer.Analyze();

//// 正常に分析できたかチェック
//if (result.Reason == ImageAnalysisResultReason.Analyzed)
//{
//    if (result.Objects != null)
//    {
//        Console.WriteLine("Object:");
//        foreach (var obj in result.Objects)
//        {
//            Console.WriteLine(obj.Name);
//        }
//    }
//}


//リスト7-11-4

//using Azure;
//using Azure.AI.ContentSafety;
//var END_POINT = "《エンドポイント》"; //☆
//var SAFETY_KEY = "《リソースキー》"; //☆

//Console.Write("prompt: ");
//var prompt = Console.ReadLine();

//// AnalyzeTextOptionsの作成
//var text_option = new AnalyzeTextOptions(prompt);

//// ContentSafetyClientの作成
//ContentSafetyClient client = new ContentSafetyClient(
//　　　　new Uri(END_POINT),
//　　　　new AzureKeyCredential(SAFETY_KEY));
//try
//{
//    // AnalyzeTextを実行
//    var response = client.AnalyzeText(text_option);
//　　// response.Value内の各値を出力する
//    var values = response.Value;
//    Console.WriteLine("Hate: {0}", values.HateResult?.Severity ?? 0);
//    Console.WriteLine("SelfHarm: {0}", values.SelfHarmResult?.Severity ?? 0);
//    Console.WriteLine("Sexual: {0}", values.SexualResult?.Severity ?? 0);
//    Console.WriteLine("Violence: {0}", values.ViolenceResult?.Severity ?? 0);
//}
//catch (RequestFailedException ex)
//{
//    // 例外発生時のステータス、エラーコード、エラーメッセージを表示
//    Console.WriteLine("FAILED!! Status: {0}, Error: {1}, Message: {2}", ex.Status, ex.ErrorCode, ex.Message);
//    throw;
//}