﻿//パッケージマネージャーコンソールに
//dotnet add package Azure.AI.OpenAI --prerelease
//の入力が必要です

//以下、お使いになるプログラムの行頭コメント（//）を削除して使ってください。

//コメントの削除は［Ctrl(command)］＋［K］→［Ctrl(command)］＋［U］キー
//コメントをつけるには［Ctrl(command)］＋［K］→［Ctrl(command)］＋［C］キー



//リスト3-7-1
using Azure;
using Azure.AI.OpenAI;

const string API_KEY = "《APIキー》"; // ☆
const string END_POINT = "《エンドポイント》"; // ☆
const string MODEL_NAME = "《デプロイ名》"; // ☆

var client = new OpenAIClient(
    new Uri(END_POINT),
    new AzureKeyCredential(API_KEY));

Console.Write("prompt: ");
string prompt = Console.ReadLine() ?? "Hello.";

var response = client.GetChatCompletions(
    MODEL_NAME,
    new ChatCompletionsOptions()
    {
        Messages = {
            new ChatRequestUserMessage(prompt),
        },
    });

ChatCompletions completions = response.Value;
Console.Write("Result: ");
Console.WriteLine(completions.Choices[0].Message.Content);



//リスト3-8-1
//using Azure;
//using Azure.AI.OpenAI;
//const string API_KEY = "《APIキー》"; // ☆
//const string END_POINT = "《エンドポイント》"; // ☆
//const string MODEL_NAME = "《デプロイ名》"; // ☆

//var client = new OpenAIClient(
//    new Uri(END_POINT),
//    new AzureKeyCredential(API_KEY));

//bool flag = true;

//while (flag) 
//{
//    Console.Write("prompt: ");
//    string prompt = Console.ReadLine() ?? "Hello.";
//    if (prompt == "")
//    {
//        flag = false;
//    }
//    else
//    {
//        var response = client.GetChatCompletions(
//            MODEL_NAME,
//            new ChatCompletionsOptions()
//            {
//                Messages = {
//                    new ChatRequestUserMessage(prompt)
//                }
//            });
//        ChatCompletions completions = response.Value;
//        Console.Write("Result: "); 
//        Console.WriteLine(completions.Choices[0].Message.Content);
//   }
//}


//リスト3-8-2
//using Azure;
//using Azure.AI.OpenAI;
//const string API_KEY = "《APIキー》"; // ☆
//const string END_POINT = "《エンドポイント》"; // ☆
//const string MODEL_NAME = "《デプロイ名》"; // ☆

//var client = new OpenAIClient(
//    new Uri(END_POINT),
//    new AzureKeyCredential(API_KEY));

//var options = new ChatCompletionsOptions(); 

//bool flag = true;

//while (flag)
//{
//    Console.Write("prompt: ");
//    string prompt = Console.ReadLine() ?? "Hello.";
//    if (prompt == "")
//    {
//        flag = false;
//    }
//    else
//    {
//        options.Messages.Add(new ChatRequestUserMessage(prompt)); 

//        var response = client.GetChatCompletions(
//            MODEL_NAME,
//            options); 

//        ChatCompletions completions = response.Value;
//        Console.Write("Result: ");
//        Console.WriteLine(completions.Choices[0].Message.Content);
//        options.Messages.Add(completions.Choices[0].Message);
//    }
//}


//リスト3-9-1
//using Azure;
//using Azure.AI.OpenAI;
//const string API_KEY = "《APIキー》"; // ☆
//const string END_POINT = "《エンドポイント》"; // ☆
//const string MODEL_NAME = "《デプロイ名》"; // ☆

//var client = new OpenAIClient(
//    new Uri(END_POINT),
//    new AzureKeyCredential(API_KEY));

//var options = new ChatCompletionsOptions();
options.Messages.Add(new ChatRequestUserMessage(
//"あなたはフランス語翻訳アシスタントです。ユーザーが入力した文をすべてフランス語にします。"));

//bool flag = true;
//while (flag)
//{
//    Console.Write("prompt: ");
//    string prompt = Console.ReadLine() ?? "Hello.";
//    if (prompt == "")
//    {
//        flag = false;
//    }
//    else
//    {
        options.Messages.Add(new ChatRequestUserMessage(prompt));
//        var response = client.GetChatCompletions(
//            MODEL_NAME,
//            options);
//        ChatCompletions completions = response.Value;
//        Console.Write("Result: ");
//        Console.WriteLine(completions.Choices[0].Message.Content);
//        options.Messages.Add(completions.Choices[0].Message);
//    }
//}


//リスト3-9-2
//using Azure;
//using Azure.AI.OpenAI;
//const string API_KEY = "《APIキー》"; // ☆
//const string END_POINT = "《エンドポイント》"; // ☆
//const string MODEL_NAME = "《デプロイ名》"; // ☆
//var client = new OpenAIClient(
//    new Uri(END_POINT),
//    new AzureKeyCredential(API_KEY));

//var options = new ChatCompletionsOptions();
//options.Messages.Add(new ChatRequestSystemMessage(
//    "あなたは武士アシスタントです。武家言葉で会話します。"));
//options.Messages.Add(new ChatRequestUserMessage(
//    "こんにちは。あなたの名前は？"));
///options.Messages.Add(new ChatRequestAssistantMessage(
//    "お初にお目にかかり申す。拙者、OpenAIと申すものでござる。"));

//bool flag = true;
//while (flag)
//{
//    Console.Write("prompt: ");
//    string prompt = Console.ReadLine() ?? "Hello.";
//    if (prompt == "")
//    {
//        flag = false;
//    }
//    else
//    {
//        options.Messages.Add(new ChatRequestUserMessage(prompt));
//        var response = client.GetChatCompletions(
//            MODEL_NAME,
//            options);
//        ChatCompletions completions = response.Value;
//        Console.Write("Result: ");
//        Console.WriteLine(completions.Choices[0].Message.Content);
//        options.Messages.Add(completions.Choices[0].Message);
//    }
//}



//リスト3-10-1
//using Azure;
//using Azure.AI.OpenAI;
//const string API_KEY = "《APIキー》"; // ☆
//const string END_POINT = "《エンドポイント》"; // ☆
//const string MODEL_NAME = "《デプロイ名》"; // ☆

//var client = new OpenAIClient(
//    new Uri(END_POINT),
//    new AzureKeyCredential(API_KEY));

//var options = new ChatCompletionsOptions();
//options.MaxTokens = 100;
//options.StopSequences.Add("。");
//options.StopSequences.Add(".");

//bool flag = true;
//while (flag)
//{
//    Console.Write("prompt: ");
//    string prompt = Console.ReadLine() ?? "Hello.";
//    if (prompt == "")
//    {
//        flag = false;
//    }
//    else
//    {
//        options.Messages.Add(new ChatRequestUserMessage(prompt));
//        var response = client.GetChatCompletions(
//            MODEL_NAME,
//            options);
//        ChatCompletions completions = response.Value;
//        Console.Write("Result: ");
//        Console.WriteLine(completions.Choices[0].Message.Content);
//        options.Messages.Add(completions.Choices[0].Message);
//    }
//}


//リスト3-11-1,3-11-2
//using Azure;
//using Azure.AI.OpenAI;
//const string API_KEY = "《APIキー》"; // ☆
//const string END_POINT = "《エンドポイント》"; // ☆
////const string MODEL_NAME = "《デプロイ名》"; // ☆
//var client = new OpenAIClient(
//new Uri(END_POINT),
//new AzureKeyCredential(API_KEY));

//Console.Write("prompt: ");
//string prompt = Console.ReadLine() ?? "Hello.";

//var options = new ChatCompletionsOptions();
//options.Messages.Add(new ChatRequestUserMessage(prompt));
//options.MaxTokens = 1000;
//options.Temperature = 0.0f; //☆

//以下3-11-2
//options.NucleusSamplingFactor = 1.0f; //☆

//var response = client.GetChatCompletions(
//    MODEL_NAME,
//    options);
//ChatCompletions completions = response.Value;
//Console.Write("[Result] ");
//Console.WriteLine(completions.Choices[0].Message.Content);


////リスト3-12-1,3-12-2,3-12-3
//using Azure;
//using Azure.AI.OpenAI;
//const string API_KEY = "《APIキー》"; // ☆
//const string END_POINT = "《エンドポイント》"; // ☆
//const string MODEL_NAME = "《デプロイ名》"; // ☆

//var client = new OpenAIClient(
//    new Uri(END_POINT),
//    new AzureKeyCredential(API_KEY));

//Console.Write("prompt: ");
//string prompt = Console.ReadLine() ?? "Hello.";

//var options = new ChatCompletionsOptions();
//options.Messages.Add(new ChatRequestUserMessage(prompt));
//options.MaxTokens = 1000;
//options.FrequencyPenalty = 0.0f; //☆

//以下3-12-2
//options.PresencePenalty = 0.0f; //☆

//以下3-12-3
//options.TokenSelectionBiases.Add(13068, -10); 
//options.TokenSelectionBiases.Add(new KeyValuePair<int, int>(14783, -12)); 

//var response = client.GetChatCompletions(
//    MODEL_NAME,
//    options);
//ChatCompletions completions = response.Value;
//Console.Write("[Result] ");
//Console.WriteLine(completions.Choices[0].Message.Content);


////リスト3-13-1
//using azure;
//using azure.ai.openai;
//const string api_key = "《apiキー》"; // ☆
//const string end_point = "《エンドポイント》"; // ☆
//const string model_name = "《デプロイ名》"; // ☆

//var client = new openaiclient(
//    new uri(end_point),
//    new azurekeycredential(api_key));

//var options = new chatcompletionsoptions();

//bool flag = true;
//while (flag)
//{
//    console.write("prompt: ");
//    string prompt = console.readline() ?? "hello.";
//    if (prompt == "")
//    {
//        flag = false;
//    }
//    else
//    {
//        options.messages.add(new ChatRequestUserMessage(prompt));

//        var response = client.getchatcompletionsstreaming(
//             deploymentormodelname: model_name,
//             options);
//        var streaming = response.value;

//        await foreach (var choice in streaming.getchoicesstreaming())
//        {
//            await foreach (var message in choice.getmessagestreaming())
//            {
//                console.write(message.content);
//            }
//            console.writeline();
//        }
//    }
//}


//リスト3-14-1
//using Azure;
//using Azure.AI.OpenAI;
//const string API_KEY = "《APIキー》"; // ☆
//const string END_POINT = "《エンドポイント》"; // ☆
//const string MODEL_NAME = "《デプロイ名》"; // ☆

//var client = new OpenAIClient(
//    new Uri(END_POINT),
//    new AzureKeyCredential(API_KEY));

//var options = new ChatCompletionsOptions();
//bool flag = true;

//while (flag)
//{
//    Console.Write("prompt: ");
//    string prompt = Console.ReadLine() ?? "Hello.";
//    if (prompt == "")
//    {
//        flag = false;
//    }
//    else
//    {
//        options.Messages.Add(new ChatMessage(ChatRole.User, prompt));
//        var taskChatCompletions = client.GetChatCompletionsAsync(
//        MODEL_NAME,
//        options);
//        _ = taskChatCompletions.ContinueWith(task =>
//        {
//            if (task.IsCompleted)
//            {
//                var response = task.Result;
//                var completion = response.Value;
//                var msg = completion.Choices[0].Message;
//                Console.Write("[Result] ");
//                Console.WriteLine(msg.Content);
//            }
//        });
//    }
//}


////リスト3-16-1
//using Azure;
//using Azure.AI.OpenAI;

//const string API_KEY = "《APIキー》"; // ☆
//const string END_POINT = "《エンドポイント》"; // ☆
//const string MODEL_NAME = "《デプロイ名》"; // ☆


//var client = new OpenAIClient(
//    new Uri(END_POINT),
//    new AzureKeyCredential(API_KEY));


//Console.Write("prompt: ");//★
//string prompt = Console.ReadLine() ?? "Hello.";

//var options = new CompletionsOptions()
//{
//    Prompts = { prompt },
//MaxTokens = 1000,
//};

//var response = client.GetCompletions(
//    MODEL_NAME,
//    options);

//var completion = response.Value;
//var msg = completion.Choices[0].Text;
//Console.Write("[Result] ");
//Console.WriteLine(msg.Trim());


//リスト3-16-2
//using Azure;
//using Azure.AI.OpenAI;

//const string API_KEY = "《APIキー》"; // ☆
//const string END_POINT = "《エンドポイント》"; // ☆
//const string MODEL_NAME = "《デプロイ名》"; // ☆

//var client = new OpenAIClient(
//    new Uri(END_POINT),
//    new AzureKeyCredential(API_KEY));

//Console.Write("prompt: ");
//string prompt = Console.ReadLine() ?? "Hello.";

//var options = new CompletionsOptions()
//{
//    MaxTokens = 1000,
//};

//options.Prompts.Add("簡単に自己紹介して下さい。");
//options.Prompts.Add(prompt);
//options.Prompts.Add("さよならの挨拶をして下さい。");


//var response = client.GetCompletions(
//    MODEL_NAME,
//    options);

//var completion = response.Value;
//Console.Write("[Result] ");
//foreach (var item in completion.Choices)
//{
//    Console.WriteLine(item.Text);
//}



//リスト3-16-3
//using Azure;
//using Azure.AI.OpenAI;

//const string API_KEY = "《APIキー》"; // ☆
//const string END_POINT = "《エンドポイント》"; // ☆
//const string MODEL_NAME = "《デプロイ名》"; // ☆

//var client = new OpenAIClient(
//    new Uri(END_POINT),
//    new AzureKeyCredential(API_KEY));

//Console.Write("prompt: ");
//string prompt = Console.ReadLine() ?? "Hello.";

//var options = new CompletionsOptions()
//{
//    Prompts = { "以下を英訳して下さい。\n\n" + prompt },
//    MaxTokens = 1000,
//};

//var response = client.GetCompletions(
//    MODEL_NAME,
//    options);

//var completion = response.Value;
//Console.Write("[Result] ");
//Console.WriteLine(completion.Choices[0].Text.Trim());



//リスト3-16-4
//using Azure;
//using Azure.AI.OpenAI;

//const string API_KEY = "《APIキー》"; // ☆
//const string END_POINT = "《エンドポイント》"; // ☆
//const string MODEL_NAME = "《デプロイ名》"; // ☆

//var client = new OpenAIClient(
//    new Uri(END_POINT),
//    new AzureKeyCredential(API_KEY));

//Console.Write("prompt: ");
//string prompt = Console.ReadLine() ?? "Hello.";


//var prompts = new string []{
//    "あなたはメイド喫茶のメイドです。",
//    "メイド言葉で喋ります。",
//    "ユーザーのことは「御主人様」と呼びます。　",
//    prompt
//};


//var options = new CompletionsOptions()
//{
//    Prompts = { string.Join("\n", prompts) },
//    MaxTokens = 1000,
//};

//var response = client.GetCompletions(
//    MODEL_NAME,
//    options);

//var completion = response.Value;
//Console.Write("[Result] ");
//Console.WriteLine(completion.Choices[0].Text.Trim());



//リスト3-16-5
//using Azure;
//using Azure.AI.OpenAI;

//const string API_KEY = "《APIキー》"; // ☆
//const string END_POINT = "《エンドポイント》"; // ☆
//const string MODEL_NAME = "《デプロイ名》"; // ☆

//var client = new OpenAIClient(
//    new Uri(END_POINT),
//    new AzureKeyCredential(API_KEY));

//Console.Write("prompt: ");
//string prompt = Console.ReadLine() ?? "Hello.";


//var prompts = new string []{
//    "あなたは尊大な老人です。若造に舐められないように偉そうに振る舞います。",
//    "",
//    "User: こんにちは。",
//    "Assistant: ふん、何のようじゃ。",
//    "User: 私は山田です。あなたは？",
//    "Assistant: ふん、お前なんぞに教えたくないわい。",
//    "User: よろしくお願いします。",
//    "Assistant: ふん、まあお願いされてやってもよかろう。今日は何のようじゃ？",
//    "User: " + prompt,
//    "Assistant: "
//};


//var options = new CompletionsOptions()
//{
//    Prompts = { string.Join("\n", prompts) },
//    MaxTokens = 1000,
//};

//var response = client.GetCompletions(
//    MODEL_NAME,
//    options);

//var completion = response.Value;
//Console.Write("[Result] ");
//Console.WriteLine(completion.Choices[0].Text.Trim());



//リスト3-16-6
//using Azure;
//using Azure.AI.OpenAI;

//const string API_KEY = "《APIキー》"; // ☆
//const string END_POINT = "《エンドポイント》"; // ☆
//const string MODEL_NAME = "《デプロイ名》"; // ☆

//var client = new OpenAIClient(
//    new Uri(END_POINT),
//    new AzureKeyCredential(API_KEY));

//Console.Write("prompt: ");
//string prompt = Console.ReadLine() ?? "Hello.";


//var prompts = new string []{
//    "プロンプトを分析し、中学高校の教科から関連するものを表示して下さい。",
//    "",
//    "プロンプト：夏目漱石の「坊っちゃん」の初稿が発見された。",
//    "関連教科：現代国語,日本史",
//    "プロンプト：「イプシロンS」の燃焼試験で爆発事故が発生した。",
//    "関連教科：物理,化学",
//    "プロンプト： " + prompt,
//    "関連教科： "
//};


//var options = new CompletionsOptions()
//{
//    Prompts = { string.Join("\n", prompts) },
//    MaxTokens = 1000,
//};

//var response = client.GetCompletions(
//    MODEL_NAME,
//    options);

//var completion = response.Value;
//Console.Write("[Result] ");
//Console.WriteLine(completion.Choices[0].Text.Trim());

