﻿//パッケージマネージャーコンソールに
//dotnet add package Azure.AI.OpenAI --prerelease
//dotnet add package OpenAI
//の入力が必要です

//以下、お使いになるプログラムの行頭コメント（//）を削除して使ってください。

//コメントの削除は［Ctrl(command)］＋［K］→［Ctrl(command)］＋［U］キー
//コメントをつけるには［Ctrl(command)］＋［K］→［Ctrl(command)］＋［C］キー


// リスト4-5-2
using OpenAI_API;
const string API_KEY = "《APIキー》"; // ☆
var client = new OpenAIAPI(API_KEY);
Console.Write("prompt: ");
var prompt = Console.ReadLine() ?? "Hello.";
var ct = await client.Chat.CreateChatCompletionAsync(prompt);
Console.WriteLine(ct.Choices[0].Message.Content);

// リスト4-5-3
//using OpenAI_API;
//const string API_KEY = "《APIキー》"; // ☆
//var client = new OpenAIAPI(API_KEY);

//Console.Write("prompt: ");
//var prompt = Console.ReadLine() ?? "Hello.";

//var chat = client.Chat.CreateConversation();
//// システム
//chat.AppendSystemMessage("あなたは翻訳アシスタントです。メッセージをすべて英語に翻訳してください。");
//// サンプル
//chat.AppendUserInput("こんにちは。元気ですか？");
//chat.AppendExampleChatbotOutput("Hello. How are you?");
//// メッセージの追加
//chat.AppendUserInput(prompt); 
//string response = await chat.GetResponseFromChatbotAsync();
//Console.WriteLine(response);



//P.151の実装例１
//using OpenAI_API;
//using OpenAI_API.Chat;
//using OpenAI_API.Models;

//const string API_KEY = "《APIキー》"; // ☆
//var client = new OpenAIAPI(API_KEY);
//Console.Write("prompt: ");
//var prompt = Console.ReadLine() ?? "Hello.";

//var ct = await client.Chat.CreateChatCompletionAsync(
//new ChatRequest()
//{
//    Model = Model.GPT4, //モデル指定
//    Temperature = 0.1, //温度
//    MaxTokens = 200, //最大トークン数
//    Messages =  {
//        new ChatRequestUserMessage(prompt)
//    } //メッセージデータ
//}
//);

//Console.WriteLine(ct.Choices[0].Message.Content);



//P.151の実装例２
//using OpenAI_API;
//using OpenAI_API.Chat;
//using OpenAI_API.Models;

//const string API_KEY = "《APIキー》"; // ☆
//var client = new OpenAIAPI(API_KEY);
//bool flag = true;

//while (flag)
//{
//    Console.Write("prompt: ");
//    var prompt = Console.ReadLine() ?? "Hello.";

//    if (prompt == "")
//    {
//        flag = false;
//    }
//    else
//    {
//        var ct = await client.Chat.CreateChatCompletionAsync(
//            new ChatRequest()
//            {
//                Model = Model.GPT4, //モデル指定
//                Temperature = 0.1, //温度
//                MaxTokens = 200, //最大トークン数
//                Messages =  {
//                    new ChatRequestUserMessage(prompt)
//                } //メッセージデータ
//            }
//        );
//        Console.WriteLine(ct.Choices[0].Message.Content);
//    }
//}



//リスト4-6-1
//using OpenAI_API;
//using OpenAI_API.Completions;
//using OpenAI_API.Models;

//const string API_KEY = "《APIキー》"; // ☆
//var client = new OpenAIAPI(API_KEY);

//Console.Write("prompt: ");
//var prompt = Console.ReadLine() ?? "Hello.";

////★Completionsにアクセスする
//var completion_result = await client.Completions.CreateCompletionAsync(prompt);
//Console.Write(completion_result.Completions[0].Text);


//リスト4-6-2
//using OpenAI_API;
//using OpenAI_API.Completions;
//using OpenAI_API.Models;

//const string API_KEY = "《APIキー》"; // ☆
//var client = new OpenAIAPI(API_KEY);

//Console.Write("prompt: ");
//var prompt = Console.ReadLine() ?? "Hello.";

//var request = new CompletionRequest(prompt);
//request.Model = Model.DavinciText;
//request.MaxTokens = 500;
//var completion_result = await client.Completions.CreateCompletionAsync(request);
//Console.Write(completion_result.Completions[0].Text);


//リスト4-7-1
//using OpenAI_API;
//using OpenAI_API.Completions;
//using OpenAI_API.Models;

//const string API_KEY = "《APIキー》"; // ☆
//const string INSTANCE_NAME = "《インスタンス名》"; // ☆
//const string MODEL_NAME = "《デプロイ名》"; // ☆

//var client = OpenAIAPI.ForAzure(INSTANCE_NAME, MODEL_NAME, API_KEY);

//Console.Write("prompt: ");
//var prompt = Console.ReadLine() ?? "Hello.";

//var request = new CompletionRequest(prompt);
//request.MaxTokens = 200;

//var completion_result = await client.Completions.CreateCompletionAsync(request);
//Console.Write(completion_result.Completions[0].Text);


//リスト4-8-1
//using OpenAI_API;
//using OpenAI_API.Images;

//const string API_KEY = "《APIキー》"; // ☆

//var client = new OpenAIAPI(API_KEY);

//Console.Write("prompt: ");
//var prompt = Console.ReadLine() ?? "Hello.";

//var response = await client.ImageGenerations.CreateImageAsync(prompt); 
//Console.WriteLine(response.Data[0].Url);


//リスト4-8-2
//using OpenAI_API;
//using OpenAI_API.Images;
//const string API_KEY = "《APIキー》"; // ☆

//var client = new OpenAIAPI(API_KEY);

//Console.Write("prompt: ");
//var prompt = Console.ReadLine() ?? "Hello.";

//var img_request = new ImageGenerationRequest(prompt);
//img_request.NumOfImages = 1;
//img_request.Size = ImageSize._256;
//var response = await client.ImageGenerations.CreateImageAsync(img_request);

//Console.WriteLine(response.Data[0].Url);


//リスト4-8-3
//using System.IO;
//using OpenAI_API;
//using OpenAI_API.Images;
//const string API_KEY = "《APIキー》"; // ☆

//var client = new OpenAIAPI(API_KEY);

//Console.Write("prompt: ");
//var prompt = Console.ReadLine() ?? "Hello.";

//var img_request = new ImageGenerationRequest(prompt, 1);
//img_request.NumOfImages = 1;
//img_request.Size = ImageSize._512;
//img_request.ResponseFormat = ImageResponseFormat.B64_json;
//var response = await client.ImageGenerations.CreateImageAsync(img_request);

//byte[] image_data = Convert.FromBase64String(response.Data[0].Base64Data);

//string fpath = "dalle_image.png";
//File.WriteAllBytes(fpath, image_data);
//Console.WriteLine(fpath + " に保存しました。");



